SystemOrganization addCategory: #Reflectogram!
SystemOrganization addCategory: 'Reflectogram-Benchmarks'!
SystemOrganization addCategory: 'Reflectogram-Case-Study'!
SystemOrganization addCategory: 'Reflectogram-Conditions-Actions'!
SystemOrganization addCategory: 'Reflectogram-Events'!
SystemOrganization addCategory: 'Reflectogram-Graph-Points'!
SystemOrganization addCategory: 'Reflectogram-Modes'!
SystemOrganization addCategory: 'Reflectogram-Targets'!

BlockClosure variableSubclass: #MetaAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Conditions-Actions'!

MetaAction variableSubclass: #InstallationMetaAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Conditions-Actions'!

MetaAction variableSubclass: #JumpMetaAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Conditions-Actions'!

MetaAction variableSubclass: #UserMetaAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Conditions-Actions'!

BlockClosure variableSubclass: #MetaCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Conditions-Actions'!

MetaCondition variableSubclass: #InstallationMetaCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Conditions-Actions'!

MetaCondition variableSubclass: #JumpMetaCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Conditions-Actions'!

MetaCondition variableSubclass: #UserMetaCondition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Conditions-Actions'!

Object subclass: #BenchAll
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Benchmarks'!

Object subclass: #Event
	uses: TRBProgramNodeVisitor
	instanceVariableNames: 'link'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

Event class
	uses: TRBProgramNodeVisitor classTrait
	instanceVariableNames: ''!

!Event methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 18:08'!
annotateMethod: aMethod withLink: aMetaLink 

	link := aMetaLink.
	self visitNode: aMethod ast! !

!Event methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 20:08'!
scope

	self subclassResponsibility ! !

Event subclass: #MultiScopedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

MultiScopedEvent subclass: #MSGReceive
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!MSGReceive methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 20:00'!
visitMessageNode: aMessageNode 
	aMessageNode link: link.
	^ super visitMessageNode: aMessageNode.! !

!MultiScopedEvent methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 20:11'!
scope

	^ MultiScoped! !

MultiScopedEvent subclass: #ObjectCreation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!ObjectCreation methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 20:03'!
visitMethodNode: aMethodNode 
	aMethodNode link: link.
	^ super visitMethodNode: aMethodNode.! !

MultiScopedEvent subclass: #PassedAsArg
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!PassedAsArg methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 20:04'!
visitMessageNode: aMessageNode 
	aMessageNode link: link.
	^ super visitMessageNode: aMessageNode.! !

MultiScopedEvent subclass: #Returned
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!Returned methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 20:04'!
visitReturnNode: aReturnNode 
	aReturnNode link: link.
	^ super visitReturnNode: aReturnNode.! !

MultiScopedEvent subclass: #Stored
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!Stored methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 20:06'!
visitAssignmentNode: anAssignmentNode
	anAssignmentNode link: link.
	^ super visitAssignmentNode: link.! !

!Stored methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 18:05'!
visitStoreIntoTempNode: aNode
	^ aNode! !

Event subclass: #SingleScopedEvent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

SingleScopedEvent subclass: #IVRead
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!IVRead methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 18:12'!
visitVariableNode: aVariableNode
	aVariableNode link: link.
	^ super visitVariableNode: aVariableNode.! !

SingleScopedEvent subclass: #IVWrite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!IVWrite methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 18:12'!
visitAssignmentNode: anAssignmentNode
	anAssignmentNode link: link.
	^ super visitAssignmentNode: anAssignmentNode.! !

SingleScopedEvent subclass: #MSGSend
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!MSGSend methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 18:14'!
visitMessageNode: aMessageNode 
	aMessageNode link: link.
	^ super visitMessageNode: aMessageNode.! !

SingleScopedEvent subclass: #MethodExecution
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!MethodExecution methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 18:36'!
visitMethodNode: aMethodNode 
	aMethodNode link: link.
	^ super visitMethodNode: aMethodNode.! !

SingleScopedEvent subclass: #Return
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!Return methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 18:38'!
visitReturnNode: aReturnNode 

		aReturnNode link: link.
		^ super visitReturnNode: aReturnNode.! !

!SingleScopedEvent methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 20:11'!
scope

	^ SingleScoped! !

SingleScopedEvent subclass: #TempRead
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!TempRead methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 18:48'!
visitTemporaryNode: aNode 
	"Sent *each time* a temporary node is found"
	aNode link: link.
	^ super visitTemporaryNode: aNode.! !

SingleScopedEvent subclass: #TempStore
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Events'!

!TempStore methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 18:50'!
visitStoreIntoTempNode: aNode
	aNode link: link.
	^ super visitStoreIntoTempNode: aNode.! !

Object subclass: #Mode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

Mode subclass: #Scope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

Scope subclass: #MultiScoped
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

Scope subclass: #SingleScoped
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

SingleScoped subclass: #LexicallyScoped
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

SingleScoped subclass: #RunTimeScoped
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

Mode subclass: #Semantics
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

!Semantics commentStamp: 'NickPapoulias 7/23/2015 19:16' prior: 0!
semantics of hierarchy and reification!

Semantics subclass: #FlatEntity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

Semantics subclass: #FlatGroup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

Semantics subclass: #InheritanceEntity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

Semantics subclass: #InheritanceGroup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Modes'!

Object subclass: #Reflectogram
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Graph-Points'!

!Reflectogram class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 19:15'!
on: anEntity as: aSemanticsClass for: anEvent limitedTo: installationCondition when: userCondition do: userAction

	"installation condition can be method | class | package"! !

!Reflectogram class methodsFor: 'as yet unclassified' stamp: 'NickPapoulias 7/23/2015 20:07'!
on: anEntity for: anEvent limitedTo: installationCondition when: userCondition do: userAction

	"installation condition can be method | class | package"! !

Reflectogram subclass: #ReflectogramGraph
	instanceVariableNames: 'target event metaConditionGroup metaActionGroup trace points'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Graph-Points'!

Reflectogram subclass: #ReflectogramPoint
	instanceVariableNames: 'graph reifications time level'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Graph-Points'!

Object subclass: #ReflectogramVisualization
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Graph-Points'!

Object subclass: #Reifications
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Graph-Points'!

Object subclass: #Target
	instanceVariableNames: 'target scope inheritance reification'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Targets'!

Target subclass: #ClassTarget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Targets'!

Target subclass: #ContextTarget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Targets'!

Target subclass: #ImageTarget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Targets'!

Target subclass: #MethodTarget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Targets'!

Target subclass: #ObjectTarget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Targets'!

Target subclass: #PackageTarget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Targets'!

Target subclass: #ProcessTarget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Targets'!

!Target methodsFor: 'accessing' stamp: 'NickPapoulias 7/23/2015 16:35'!
inheritance
	^ inheritance! !

!Target methodsFor: 'accessing' stamp: 'NickPapoulias 7/23/2015 16:35'!
inheritance: anObject
	inheritance := anObject! !

!Target methodsFor: 'accessing' stamp: 'NickPapoulias 7/23/2015 18:23'!
reification
	^ reification! !

!Target methodsFor: 'accessing' stamp: 'NickPapoulias 7/23/2015 18:23'!
reification: anObject
	reification := anObject! !

!Target methodsFor: 'accessing' stamp: 'NickPapoulias 7/23/2015 16:35'!
scope
	^ scope! !

!Target methodsFor: 'accessing' stamp: 'NickPapoulias 7/23/2015 16:35'!
scope: anObject
	scope := anObject! !

!Target methodsFor: 'accessing' stamp: 'NickPapoulias 7/23/2015 16:36'!
target
	^ target! !

!Target methodsFor: 'accessing' stamp: 'NickPapoulias 7/23/2015 16:36'!
target: anObject
	target := anObject! !

Object subclass: #WebApp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Reflectogram-Case-Study'!
